#include "ButtonPanel.h"

enum {ID_BUTTON_ACCOUNT=1, ID_BUTTON_STATS, ID_BUTTON_SEARCH, ID_BUTTON_PREFS, ID_BUTTON_CHANGE_USER, ID_BUTTON_ABOUT, ID_BUTTON_QUIT};

BEGIN_EVENT_TABLE(ButtonPanel, wxPanel)
EVT_BUTTON(ID_BUTTON_ACCOUNT, ButtonPanel::OnButtonAccount)
EVT_BUTTON(ID_BUTTON_PREFS, ButtonPanel::OnButtonPreferences)
EVT_BUTTON(ID_BUTTON_CHANGE_USER, ButtonPanel::OnButtonChangeUser)
EVT_BUTTON(ID_BUTTON_ABOUT, ButtonPanel::OnButtonAbout)
EVT_BUTTON(ID_BUTTON_QUIT, ButtonPanel::OnButtonQuit)
END_EVENT_TABLE()

ButtonPanel::ButtonPanel(KissCount* kiss, wxUI *parent) : wxPanel(&(*parent)), _kiss(kiss), _wxUI(parent)
{
  wxBoxSizer *hbox = new wxBoxSizer(wxHORIZONTAL);
  _account = new wxBitmapButton(this, ID_BUTTON_ACCOUNT, wxBitmap(wxT(ACCOUNT_ICON)), wxDefaultPosition, wxSize(128, 128));
  _stats = new wxBitmapButton(this, ID_BUTTON_STATS, wxBitmap(wxT(STATS_ICON)), wxDefaultPosition, wxSize(128, 128));
  _search = new wxBitmapButton(this, ID_BUTTON_SEARCH, wxBitmap(wxT(SEARCH_ICON)), wxDefaultPosition, wxSize(128, 128));
  _prefs = new wxBitmapButton(this, ID_BUTTON_PREFS, wxBitmap(wxT(PREFS_ICON)), wxDefaultPosition, wxSize(128, 128));
  _changeUser = new wxBitmapButton(this, ID_BUTTON_CHANGE_USER, wxBitmap(wxT(CHANGE_USER_ICON)), wxDefaultPosition, wxSize(128, 128));
  _about = new wxBitmapButton(this, ID_BUTTON_ABOUT, wxBitmap(wxT(ABOUT_ICON)), wxDefaultPosition, wxSize(128, 128));
  _quit = new wxBitmapButton(this, ID_BUTTON_QUIT, wxBitmap(wxT(QUIT_ICON)), wxDefaultPosition, wxSize(128, 128));

  SetSizer(hbox);

  hbox->Add(_account);
  hbox->Add(_stats);
  hbox->Add(_search);
  hbox->Add(_prefs);
  hbox->Add(_changeUser);
  hbox->Add(_about);
  hbox->Add(_quit);

  Fit();
  SetMinSize(GetSize());
}

ButtonPanel::~ButtonPanel()
{
  delete _account;
  delete _stats;
  delete _prefs;
  delete _changeUser;
}

void ButtonPanel::OnButtonAccount(wxCommandEvent& event)
{
  _wxUI->ShowAccount();
}

void ButtonPanel::OnButtonPreferences(wxCommandEvent& event)
{
  _wxUI->ShowPreferences();
}

void ButtonPanel::OnButtonChangeUser(wxCommandEvent& event)
{
  _wxUI->ChangeUser();
}

void ButtonPanel::OnButtonAbout(wxCommandEvent& event)
{
    wxMessageBox( _("KissCount v0.1\n\nLogiciel de comptabilité\n\nCopyright (C) 2010 Grégory Soutadé"),
                  wxT("KissCount"), 
                  wxOK | wxICON_INFORMATION, _wxUI );
}

void ButtonPanel::OnButtonQuit(wxCommandEvent& event)
{
  wxMessageDialog dialog(_wxUI, _("Quit KissCount ?"), wxT("KissCount"), wxYES_NO);
  if (dialog.ShowModal() == wxID_NO)
    {
      return;
    }
  _wxUI->Close(true);
}
